<?php

/*
Addon: Team_Style1
*/

class TEAMVISION_Team_Style1 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));
        add_shortcode('teamvision_team_style1', array($this, 'shortcode_addon_func'));
        add_shortcode('teamvision_team_style1_item', array($this, 'child_shortcode_addon_func'));
        add_action('init', array($this, 'map_vc_addon'));
        add_action('init', array($this, 'map_child_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'teamvision-bootstrap' );
        wp_enqueue_style( 'teamvision-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'teamvision-animations' );
		wp_enqueue_script( 'teamvision-appear' );
		wp_enqueue_script( 'teamvision-js-animations' );
		
    }

	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        extract(shortcode_atts(array(
			'columns'	=> '1',
			'custom_style' 			=> 'off',
			'title_color'			=> '#FFFFFF',
			'role_color'			=> '#000000',
			'social_color'			=> '#FFFFFF',
			'h_color'				=> '#333333',

        ), $atts));

		if($custom_style == 'on') :
		
			$css_style_to_append = "<style>
			.teamvision-team-style1-".$instance." .teamvision-team-name, 
			.teamvision-team-style1-".$instance." .teamvision-team-container-wrap span.teamvision-team-name { color:".$title_color.";}
			.teamvision-team-style1-".$instance." .teamvision-team-container-wrap span.teamvision-team-role { color:".$role_color.";}
			.teamvision-team-style1-".$instance." .teamvision-team-social-container a { color:".$social_color.";}
			.teamvision-team-style1-".$instance." a:hover { color:".$h_color."; }
			</style>";
			$data_value = 'data-teamvision-custom-css="'.$css_style_to_append.'"';
			$js_class = 'teamvision-custom-js';
		
		else :

			$js_class = $data_value = '';

		endif;
	
			$output = '<div '.$data_value.' class="teamvision teamvision-team-style1 teamvision-team-col-'.$columns.' teamvision-team-style1-'.$instance.' '.$js_class.' '.$team_style1_style.' '.$display.'">'.do_shortcode($content).'<div class="teamvision-clear"></div></div>';

        return $output;
    }
	
	/*
	 * Addon Child View
	 */
    public function child_shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'image_user' 	=> '',
			'name'			=> '',
			'role'			=> '',
			'social'		=> 'on',
			'social_target'	=> '_blank',
			'social_list'	=> '',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',			
			
        ), $atts));
		
		$elements = json_decode(urldecode($social_list));
		
		$team_image_array = wp_get_attachment_image_src( $image_user, 'large');

        $output = '<div class="teamvision-team teamvision-item-'.$instance.teamvision_animate_class($addon_animate,$effect,$delay).'>';
			$output .= '<div class="teamvision-team-container" style="background-image:url('.$team_image_array[0].');">
							<div class="teamvision-team-container-wrap">
								<span class="teamvision-team-name">'.$name.'</span>
								<span class="teamvision-team-role">'.$role.'</span>';
			if($elements) :					
				$output .= '<div class="teamvision-team-social-container">';
						foreach ( $elements as $element ) {					
							$output .= '<a href="'.$element->social_url.'" class="'.$element->social_icon.'" target="'.$target.'"></a>';			
						}        
				$output .= '</div>';
			endif;
			$output .= '</div><div class="teamvision-team-pattern"></div></div></div>';

        return $output;
    }	

		/*
	 * Addon Child Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {
            vc_map(array(
                "name" => __("Team Style 1", "teamvision"),
                "base" => "teamvision_team_style1",
                "content_element" => true,
                "as_parent" => array('only' => 'teamvision_team_style1_item'),
				"show_settings_on_create" => true,
				"is_container" => true,
				"js_view" => 'VcColumnView',
                "category" => esc_html__("Teamvision", "teamvision"),
                "icon" => TEAMVISION_URL . '/assets/img/vc-team-style.png',
                "params" => array(	
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Columns", 'teamvision'),
							"param_name" => "columns",
							"value" => array(
											esc_html__('1','teamvision') 	=> '1',
											esc_html__('2','teamvision') 	=> '2',
											esc_html__('3','teamvision') 	=> '3',
											esc_html__('4','teamvision') 	=> '4',				
							),
						),					
						// STYLE					
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Style", 'teamvision'),
							"param_name" => "custom_style",
							"value" => array(
											esc_html__('Off','teamvision') 	=> 'off',
											esc_html__('On','teamvision') 	=> 'on'
											
							),
							"group" => "Style"
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => __("Title Color", 'teamvision'),
							"param_name" => "title_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => __("Role Color", 'teamvision'),
							"param_name" => "role_color",
							"value" => '#000000',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => __("Social Color", 'teamvision'),
							"param_name" => "social_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),						
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => __("Social Hover Color", 'teamvision'),
							"param_name" => "h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						)		
				),
            ));			
		}
	}
	
	/*
	 * Addon Child Backend
	 */	
    function map_child_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => __("Member Team", "teamvision"),
                "base" => "teamvision_team_style1_item",
                "content_element" => true,
                "as_child" => array('only' => 'teamvision_team_style1'),
                "category" => esc_html__("Teamvision", "teamvision"),
                "icon" => 'addon',
                "params" => array(					
					array(
						"type" => "attach_image",
						"class" => "",
						"heading" => esc_html__("Image User Team", 'teamvision'),
						"param_name" => "image_user",
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Name",'teamvision'),
						"param_name" => "name",
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Role",'teamvision'),
						"param_name" => "role",
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social", 'teamvision'),
						"param_name" => "social",
						"value" => array(
									esc_html__('On') => 'on',
									esc_html__('Off','teamvision') => 'off'
									
						),
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social Target", 'teamvision'),
						"param_name" => "social_target",
						"value" => array(
									esc_html__('Self (Same Window)','teamvision') => '_self',
									esc_html__('Blank (New Window)','teamvision') => '_blank'
									
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
					),
					
					// SOCIAL
					array(
						'type' => 'param_group',
						'value' => '',
						'param_name' => 'social_list',
						'params' => array(
							array(
								"type" => "iconpicker",
								"heading" => esc_html__( "Icon", "teamvision" ),
								"param_name" => "social_icon",
								"settings" => array(
									"emptyIcon" 	=> false,
									"type" 			=> "fontawesome",
									"iconsPerPage" 	=> 200,
								),						
								"description" => esc_html__( "Select icon from library.", "teamvision" ),
							),						
							array(
								'type' => 'textfield',
								'value' => '',
								'heading' => esc_html__("Url Link", 'teamvision'),
								'param_name' => 'social_url',
							)
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
						"group" => "Social"
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'teamvision'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','teamvision') 	=> 'off',
										esc_html__('On','teamvision') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'teamvision'),
						"param_name" => "effect",
						"value" => teamvision_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'teamvision'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class


if (class_exists('WPBakeryShortCodesContainer')) {
    class WPBakeryShortCode_teamvision_team_style1 extends WPBakeryShortCodesContainer {
    }
}

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_teamvision_team_style1_item extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('TEAMVISION_Team_Style1')) {
    new TEAMVISION_Team_Style1();
}