<?php

if (!class_exists('Teamvision_Main')) :

    /**
     * Main Teamvision_Main Class
     *
     */	 
	class Teamvision_Main {

		private static $instance;	
		
        public static function instance() {
            if (!isset(self::$instance) && !(self::$instance instanceof Teamvision_Main)) {

                self::$instance = new Teamvision_Main;

                //self::$instance->setup_constants();

                add_action('plugins_loaded', array(self::$instance, 'load_plugin_textdomain'));

                add_action('plugins_loaded', array(self::$instance, 'includes_files'));

                add_action('plugins_loaded', array(self::$instance, 'include_addons'));

				add_action('wp_enqueue_scripts', array(self::$instance, 'load_general_scripts'));
				
                //self::$instance->hooks();

            }
            return self::$instance;
        }

        /**
         * Load Plugin Text Domain
         */
        public function load_plugin_textdomain() {
			$path = dirname(plugin_basename( __FILE__ )) . '/languages/';
			$loaded = load_plugin_textdomain( 'teamvision', false, $path);
        }		
		
		
        /**
         * Include required files
         *
         */
        public function includes_files() {

            /* Load VC Field Types */
            include_once( plugin_dir_path( __FILE__ ) . 'includes/teamvision_functions.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'includes/teamvision_helper.php' );
			
        }		

        /**
         * Include VC Addons
         *
         */
        public function include_addons() {

			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-teamvision-team-style7.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-teamvision-team-carousel-style7.php' );
			
        }

        /**
         * Load general scripts
         */
        public function load_general_scripts() {

			if (!class_exists('Mulse_Main')) {
				wp_enqueue_style( 'teamvision-fonts',  plugin_dir_url( __FILE__ ) . 'assets/css/fonts.css' );
			}
			
			wp_register_style( 'teamvision-bootstrap',  plugin_dir_url( __FILE__ ) . 'assets/css/bootstrap.css' );
			wp_register_style( 'teamvision-style',  plugin_dir_url( __FILE__ ) . 'assets/css/style.css' );
			wp_register_style( 'teamvision-owl-carousel',  plugin_dir_url( __FILE__ ) . 'assets/css/owl.carousel.min.css' );
			wp_register_style( 'teamvision-animations',  plugin_dir_url( __FILE__ ) . 'assets/css/animations.min.css' );
			wp_register_style( 'teamvision-prettyphoto',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/prettyPhoto.css' );
			wp_register_style( 'teamvision-magnific-popup',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/magnific-popup.css' );
			wp_register_style( 'teamvision-lightgallery',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/lightGallery.css' );
			wp_enqueue_script( 'jquery');
			wp_register_script( 'teamvision-appear',  plugin_dir_url( __FILE__ ) . 'assets/js/appear.min.js' );
			wp_register_script( 'teamvision-js-animations',  plugin_dir_url( __FILE__ ) . 'assets/js/animations.min.js' );					
			wp_register_script( 'teamvision-js-owlcarousel',  plugin_dir_url( __FILE__ ) . 'assets/js/owl.carousel.min.js' );
			wp_register_script( 'teamvision-js-prettyphoto',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/jquery.prettyPhoto.js' );
			wp_register_script( 'teamvision-js-magnific-popup',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/jquery.magnific-popup.js' );
			wp_register_script( 'teamvision-js-lightgallery',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/lightGallery.min.js' );
			wp_enqueue_script( 'teamvision-js',  plugin_dir_url( __FILE__ ) . 'assets/js/teamvision.js' );			
						
        }			

	}
	
	
endif; // End if class_exists check

function TEAMVISION() {
    return Teamvision_Main::instance();
}

// Get TEAMVISION Running
TEAMVISION();